<?php


/* To do: 

-	Setup runtime config system to allow use/disuse
	of plural_stem() and, when implemented, metaphone

-	Write spider.example to show how one can spider
	and HTML page.

-	During merge, track what the *longest* line is,
	then use that in find_word() to fgets() that line
	Append it to the word_offsets file.

-	work in following code:

$string = "(hans brent) john annie (carol chuck) betty";
$string = trim($string) . " ";

$length = strlen($string);

$i=0;
while($i<$length) {

	$l = substr($string,$i,1);
	if($l=="(") {
		$closing_P = strpos($string,")",$i+1);
		$opening_P = strpos($string,"(",$i+1);

	if($closing_P>$opening_P && $opening_P != 0) {
		$errormsg = "Malformed query, there can be no nesting of query groups (position $i)";
		break;
	}
	
	if($closing_P==0) {
		$errormsg = "Malformed search, possibly missing closing paran";
		break;
	}

		$h = $closing_P - ($i-1);
		$words[] = substr($string,$i,$h);
		$i = $i + $h + 1; // plus 1 because it's still sitting on the )
	} else {
		$h = strpos($string," ",$i) - ($i-1);
		$words[] = substr($string,$i,$h);
		$i = $i + $h;
	}
}

for($i=0;$i<count($words);$i++) {

	print "$words[$i]\n";

}

if(isset($errormsg)) print "\n$errormsg\n";


*/



	/*
	 *
	 * Configuration: include files needed
	 *
	 */


	require "config.php";
          /* you can move this anywhere you want,
             but you have to tell me here. */

	require 'stopwords.php';
          /* you can move this anywhere you want,
             but you have to tell me here. */




class Idx {

	/* set the name of our index... */

	function Idx ($index) {
	  $this->idx = trim($index);
	} 




		/* ****** VERSION ******* 
		   PHP3 can concat hashes with
		   +=, but PHP4 can't, it uses
		   array_merge() */

		function phpv () {	
			if(phpversion() > 3) {
				$php4 = TRUE;
			} else {
				$php4 = FALSE;
			}

		return $php4;
		}


	/*
	 * Weigh Factor:
	 *
	 * You can make words from certain areas 'weigh' more if you use
	 * this syntax in your indexing system:
	 *
	 *	index("Title","words words words :wf2: more more more :wf5: less less less");
	 * 	So, the first set (before :wf2: have normal factor, the 2nd has factor of
	 *	2, the 3rd have factor of 5 (they'll score highest and be returned first, 
	 *	most likely); 
	 */

	function is_wf ($word) {
		if(eregi(":wf([0-9]+):",$word,$regs)) {
			return (integer)$regs[1];
		} else {
			return FALSE;
		}
	}


	/* on 8/24/00 Hans added functionality for forced
	   phrase matching.  If a user searches for 'hans'
	   he would not get an entry for 'hans anderson',
	   structrued like this: 'hans+anderson'.  So, if
	   desired, you can call this function, factor, to
	   find out how many different combinations there are
	   to factor, and a list of them.  It only works in order.

	   For example, given these search terms:

		"Hans Hopkins Anderson"

	   factor() will return three items:

		"Hans+Hopkins"
		"Hopkins+Anderson"
		"Hans+Hopkins+Anderson"

	   and those will only match premade phrases
	   in the index, so if a user searches for
	   "Hans Anderson", they won't get bogus matches.
	   This was only added for a unique circumstance and isn't
	   really necessary for general use.

	*/

	function factor($f,$d) {
	 	// $f=data, $d=delimiter
		$a = explode($d,$f);
		$c = $cnt = count($a);

		if($cnt<=1) {
			return array("possibles"=>$cnt,"list"=>"$f");
		}

		$t = $c;

		for($i=0;$i<$cnt;$i++) {

			if(substr($a[$i],0,1) != '+' and
			   substr($a[$i],0,1) != '-' and
			   substr($a[$i+1],0,1) != '+' and
			   substr($a[$i+1],0,1) != '-') {

				if($i+1<$cnt) {
					$l[] = $a[$i] . "+" . $a[$i+1];
				}

				$ll[] = $a[$i];

			} else {

				$nobuildall = 1;
				// don't build the entire query into
				// word+word+word, etc

			}

			if($c<=1) break;
			$t *= --$c;

		}

		if(!isset($nobuildall) && is_array($ll)) $l[] = implode("+",$ll);
		if(is_array($l)) $l = implode(" ",$l);

	return array("possibles"=>$t,"list"=>$l);
}


function get_word_offsets($index) {

	$f = DATA_DIR . "/$index.word_offsets.data";

	if(!is_readable($f)) {
		return FALSE;
	}

	$fp = fopen($f,"r");
		$offsets = unserialize( 
			fread($fp,filesize(DATA_DIR . "/$index.word_offsets.data")) 
		);
	fclose($fp);

	return $offsets;
}


/* ************		IN_COMMON 	************

   This is a screwy little function.  Use it to find items in
   more than one associative array that are in common.  If you
   pass it an empty array, there can be nothing in common.  So, 
   if you are looping through a list of more than two arrays,
   DO NOT declare an array for the first ($m) item the FIRST
   time through.  If you do, there will never be anything in 
   common.  If you pass it an uninitiated variable the
   first time through, it will return the other.  I don't
   recommend trying to use this function for anything but this,
   as it's got lots of potential problems if not called correctly. */

function in_common($m,$n) {

	if(!is_array($m)) {		// returning n because m is not an array
		return $n;
	} elseif(!is_array($n)) {	// returning empty because n is not an array
		return array();		// can't return $m, else it'll think $m are 
					// valid results (on last time through).
	}

	$som = sizeof($m);
	if($som == 0) {
		return $n; // was array(); // was $n
	}
					 /* if it's size is 0, there can't be 
					 anything in common with the other
					 array. You might check the return
					 of this for size.  If it's 0, nothing
					 will ever be in common, and you can 
					 pretty well return to doing other
					 things without continuing to look */
	$son = sizeof($n);
	if($son == 0) {
		return $m; // array(); // was $m
	}

					 /* if it's size is 0, there can't be 
					 anything in common with the other
					 array. You might check the return
					 of this for size.  If it's 0, nothing
					 will ever be in common, and you can 
					 pretty well return to doing other
					 things without continuing to look */

        if( ($som <= $son) ) {

                while(list($k,$v) = each ($m)) {
                        if(isset($n["$k"])) $o["$k"] = $v + $n["$k"];
                }

        } else {

                while(list($k,$v) = each ($n)) {
                        if(isset($m["$k"])) $o["$k"] = $v + $m["$k"];
                }

        }

	if( !is_array($o) ) {
		return array();
	} else {
		return $o;
	}

}















  /* **************** INDEXING FUNCTIONS **************** */


	 /* *********** STOPWORDS *********
            Is the word in question a stopword?
	    If so, don't index it! Stop words are
	    defined in the file ./include.stopwords.php,
	    which is included in the indexer file. */

function is_stopword($word) {
	global $stopwords;

	if($stopwords["$word"]) {
		return TRUE;
	}

	return FALSE;
}


function plural_stem($word) {

	$w = eregi_replace("'s$","", trim($word) );

	if(eregi("[^s]s$",$w)) {
		if(eregi("sses$",$w)) {
			$w = eregi_replace("sses$","ss",$w);
		} elseif(eregi("ies$",$w)) {
			$w = eregi_replace("ies$","i",$w);
		} elseif(eregi("s$",$w)) {
			$w = eregi_replace("s$","",$w);
		}

		$did_stem = TRUE;
	}

	if($did_stem) {
		$w = eregi_replace("(.)i$","\\1y",$w);
	}

	return $w;
}



	/* **************** IS_INDEXABLE ************* 
	   This function takes the argument of 
	   a word, just one word. If this word 
	   is indexable by phpsearch, TRUE is 
	   returned.  If it's not, FALSE is returned.
	   A word may not be indexable because 
	   it's too short, too long, doesn't have 
	   enough letters, it's all numbers (if you 
	   have set that to be false), etc */

function is_indexable($word) {

	if($this->is_wf($word)) {
		return FALSE;
	}

	if( PLURAL_STEM ) {
		$nw = $this->plural_stem( $word );
	} else {
		$nw = $word;
	}

	$nw = strtolower( ereg_replace("[^@A-Za-z0-9+]","",$nw) );
	$length = strlen( trim( $nw ) );
						// to find the length, we remove any 


						 // hans added '+' to character class to allow
						 // forced phrase matches (only return if phrase, not word)

	if( 	$length < MIN_WORD_LEN or
		$length > MAX_WORD_LEN or
		$this->is_stopword($nw) ) {

		return FALSE;
	}

	return $nw;
}





	/* ********** TITLE_ADD **************
	   This function adds the title to the 
	   titles file.  Later, when searching, 
	   we'll match searches to this 'title' 
	   and output the title. */

function title_add($fp,$title) {
	global $title_pointer;

	$told1 = ftell($title_pointer);

	if( !fputs($title_pointer,"$title\n") ) {
		return FALSE;
	}

	$told2 = ftell($title_pointer) - $told1;

	return array($told1,$told2);

}



	/* ***** PURGE_INDEX ****************
	   If you don't purge the index, you
	   will add to it.  This allows you
	   to append to the index, though not
	   really 'update' it.  If you get new
	   stuff, you can index it this way.  If
	   you need to update, you'll have to 
	   purge_index(), then index().

	   There is no functionality to 'update'
           or 'delete' specific entries in the
	   index. */

function purge_index() {
	$index = $this->idx;

	if(file_exists(DATA_DIR . "/$index.titles.data")) {
		unlink(DATA_DIR . "/$index.titles.data");
	}

	for($j=0;$j<strlen(A);$j++) {
		$f = substr(A,$j,1);
	
		if(file_exists(TMP_DIR . "/$f"))
			unlink(TMP_DIR . "/$f");
		}

	return TRUE;
}






	/* ******** WRITE_ARRAY ***************
	   For each round of 'index', we write all 
	   the words, their title offsets and the 
	   number of times they appear in the entry, 
	   to an array.  Now, we open the appropriate 
	   files and write it out, to save memory. */

function write_array($a) {

	global $indexer_pointers;

	if( !is_array($a) ) {
		return FALSE; // shortcut out
	}

	while( list($k1, $v1) = each($a) ) {
         
		while( list($k2, $v2) = each($v1) ) {
			$line = "$k2";
	 
			while( list($k3, $v3) = each($v2) ) {
		        	$line .= " $k3:$v3";
		        }

			fputs($indexer_pointers["$k1"],"$line\n");
		}
	}

	 return TRUE;
}






	/**
	 *
	 * **************** INDEX ********************
	 *  This function is the guts of the indexing.
	 *  It takes a bunch of words and indexes them
	 *  (if they are not stop words, too long or
	 *  too short or are made up of any other
	 *  exceptions to our rules). After we call it,
	 *  we then call write_array, which records that
	 *  page's index.
	 *
	 */

function index($title,$words) {

	global $indexer_pointers;

	if( !$title_array = $this->title_add($title_pointer,$title) ) {
		return FALSE;			// shortcut out
	}

	list($title_offset_start,$title_offset_end) = $title_array;

	$a='';					// init/clear array
	$w = split("[^:@A-Za-z0-9+]+",$words);

						// here's an example of other languages and searcphp
						// $w = split("[^@A-Za-z0-9:+]+",$words); 
						// note the extended character set in the regex...

	for($i=0;$i<count($w);$i++) {
        	$wf = ( $weight = $this->is_wf($w[$i]) ) ? $weight : WORD_FACTOR ;

		if( $wd = $this->is_indexable($w[$i]) ) { 
			$f = substr($wd,0,1); 

			if(!eregi("[a-z0-9]",$f)) {
				continue;
			}

			$a["$f"]["$wd"]["$title_offset_start:$title_offset_end"] += $wf;
		}   
  	}

	unset($w);
	unset($wd);
	unset($words);

	if($this->write_array($a)) {
		unset($a);
		return TRUE;
	} else {
		unset($a);
		return FALSE;  
	}
 
		return TRUE;
}



/* **************** /INDEXING FUNCTIONS **************** */



























	/* ******************* I/O Functions ******************* */

	/**
	 *
	 * INDEX_OPEN: open the index to read,
	 * to retrieve search results 
	 *
	 */

function index_open($index) {

	$f = DATA_DIR . "/$index.index.data";

	if( !is_readable($f) ) return FALSE;

	return fopen($f,"r");
}


	/**
	*
	* INDEX_CLOSE: closes the index file opened to $pointer
	*
	*/

function index_close($pointer) {
	return fclose($pointer);
}



	
/* ************ INDEXER_OPEN *************** */

function indexer_open() {

	if( !is_dir(TMP_DIR) ) {
		return FALSE;
	}

	if( !is_writeable(TMP_DIR) ) {
		return FALSE;
	}

	for($j=0;$j<strlen(A);$j++) {
		$file = TMP_DIR . "/" . substr(A,$j,1);
		$f = substr(A,$j,1);
		$ary[$f] = fopen($file,"a");
	}

	return $ary; // success

}


/* ************ INDEXER_CLOSE *************** */

function indexer_close($indexer_pointers) {
	while(list($k,$v) = each($indexer_pointers)) {
		fclose($v);
	}

	return TRUE;
}






/* ************ MERGER_OPEN *************** */

function merger_open($index) {
 
	for($j=0;$j<strlen(A);$j++) {
		$f = substr(A,$j,1);
			$ary["$f"] = fopen(TMP_DIR . "/" . $f,"r");
		}

	$ary["title_offsets"] = fopen(DATA_DIR . "/$index.title_offsets.data","w");

	return $ary; 
}


/* ************ MERGER_CLOSE *************** */
function merger_close($merger_pointers) {

	while(list($k,$v) = each($merger_pointers)) {
		fclose($v);
	}

}





/* ************ TITLE_OPEN **************** */


function title_open($index,$how="r") {

	if( !is_dir(DATA_DIR) ) {
		return FALSE;
	}

	$fp = fopen(DATA_DIR . "/$index.titles.data",$how); /* SUCCESS */

	fputs($fp," "); 		// or else the first title added 
					// returns false (0) (see function.index.php)

	return $fp;

}


/* ************ TITLE_CLOSE *************** */

function title_close($title_pointer) {
	return fclose($title_pointer);
}



/* ************ TITLE_OFFSET_OPEN *************** */

function title_offsets_open($index) {

	$f = DATA_DIR . "/$index.title_offsets.data";

	if( !is_readable($f) ) {
		return FALSE;
	}

	return fopen($f,"r");
	
}


/* ************ TITLE_OFFSET_CLOSE *************** */

function title_offsets_close($pointer) {
	return fclose($pointer);
}



/* ******************* Search Functions ****************** */

	/* ******* FIND_WORD **********
          Here is where we look for the word 
          in our index. If found, returns the
          'record' (word offsets:for:titles) */

function find_word($fp,$term,$offsets) {

	if(	strlen($term)<MIN_WORD_LEN or
		strlen($term)>MAX_WORD_LEN or
		$this->is_stopword($term)) {

		return FALSE;

	}

	$term = $this->plural_stem($term);
	$f = strtolower(substr($term,0,1));

	$read_len = $offsets[$f.'e'] - $offsets[$f.'s'];

	if(fseek($fp,$offsets[$f.'s'])<0) {
		return FALSE;
	}	/* seek to the beginning of the one letter code */


	if(!$read = fread($fp,$read_len)) {
		return FALSE;
	} 	/* read the chunk of one letter code */

			     // if you want to match micro with microsoft
			     // uncomment the next line and comment the
			     // default.

			     //$spos = strpos( $read , ' ' . $term );

			     // if you want to match words in words, like
			     // 'sort' in 'assorted', uncomment the following
			     // line and comment the default

			     //$spos = strpos( $read , $term );

	// default
	$spos = strpos( $read,' '.$term.' ' );

	if($spos==0) {
		return  FALSE;
	}

	if( fseek($fp, $offsets[$f.'s'] + $spos ) <0) {
		return FALSE;
	}

			/*
			 * we've found the word, so let's retrieve
			 * the whole line. The line will contain 
			 * the offsets that will look in the title_offset.data
			 * file that will in turn get the offets for the 
			 * titles.data file
			 */ 

	return fgets($fp,40);
}




/* ********* GET_TITLE_OFFSETS *********** */

function get_title_offsets($start,$end,$word_offsets_fp) {
	fseek($word_offsets_fp,$start);
	return trim(fread( $word_offsets_fp, $end ));
}


/* ********* GET_TITLE *********** */

function get_title($start,$end,$title_offsets_fp) {
	fseek($title_offsets_fp,$start);
	return trim(fread( $title_offsets_fp, $end ));
} 


/* ********* SEARCH ************** */

function search($search_terms,$start_results=1,$num_results=10) {

	$offsets = $this->get_word_offsets($this->idx);

	$terms = split("[^-:@A-Za-z0-9+]+",$search_terms);

	if(!$fp=$this->index_open($this->idx)) {
		print "Couldn't open index\n";
		exit;
	}

	$how_many_musts=0;
	for( $i=0 ; $i<count($terms) ; $i++ )  {

		if(!$terms[$i]) {
			continue;
		}

		$term = strtolower($terms[$i]);

		$fc = substr($term,0,1);

		if($fc == '-') {
			$term = substr($term,1,strlen($term)-1);
			if(!$this->is_indexable($term)) {
				continue;
			}

         		if($fw = $this->find_word($fp,$term,$offsets)) {
				list($word,$my_word_offsets) = explode(" ", trim($fw));
				$words_found["not"] .= "$my_word_offsets ";
			}
				    				    				    
		} elseif($fc == "+") {

			$term = substr($term,1,strlen($term)-1);
			if(!$this->is_indexable($term)) {
				continue;
			}

			$this_len = strlen(ereg_replace("[^@A-za-z0-9+]","",$term));

			if($this_len < MIN_WORD_LEN) {
				continue;
			}

			$how_many_musts++;

			if($fw = $this->find_word($fp,$term,$offsets)) {
				list($word,$my_word_offsets) = explode(" ", trim($fw));
				$words_found["must"] .= "$my_word_offsets ";
				$something_found = 1;
			}

								    
		} else {

			if(!$this->is_indexable($term)) {
				continue;
			}
         		
			if($fw = $this->find_word($fp,$term,$offsets)) {
				list($word,$my_word_offsets) = explode(" ", trim($fw));
				$words_found["can"] .= "$my_word_offsets ";
				$something_found = 1;
			}

		}



	} // for loop

	$this->index_close($fp);

		if(!isset($something_found)) { 
			return FALSE;
		}

		/* now we have the offsets for the words,
		   so we look in the word_offsets.data
		   file for all of the titles that match */

		$title_offsets_fp = $this->title_offsets_open($this->idx);
		$titles_fp = $this->title_open($this->idx,"r");

		if(isset($words_found["must"])) $must = explode(" ",trim($words_found["must"]));
		if(isset($words_found["can"])) $can = explode(" ",trim($words_found["can"]));
		if(isset($words_found["not"])) $not = explode(" ",trim($words_found["not"]));

		/* for all the words that 'can' be in the
		   results (those with no + or -) */

	$cans=array();
	for($j=0;$j<count($can);$j++) {
	  list($start,$end) = explode(":",$can[$j]);
		if($this->phpv()) {
		  $cans = array_merge($cans,unserialize(trim($this->get_title_offsets($start,$end,$title_offsets_fp))));
		} else {
		  $cans += unserialize(trim($this->get_title_offsets($start,$end,$title_offsets_fp)));
		}
         }

		/* for all the words that 'must' be in the
		   results (those with a +) */

	$musts=array();
	for($j=0;$j<$how_many_musts;$j++) {
	  list($start,$end) = explode(":",$must[$j]);
     	  $newmusts = unserialize(trim($this->get_title_offsets($start,$end,$title_offsets_fp)));
	  $musts = $this->in_common($musts,$newmusts);
	  unset($newmusts);
 	}


		/* for all the words that can 'not' be in the
		   results (those with a -) */

	$nots=array();
	for($j=0;$j<count($not);$j++) {
	  list($start,$end) = explode(":",$not[$j]);
		if($this->phpv()) {
		  $nots = array_merge($nots,unserialize(trim($this->get_title_offsets($start,$end,$title_offsets_fp))));
		} else {
		  $nots += unserialize(trim($this->get_title_offsets($start,$end,$title_offsets_fp)));
		}
 	}

		/* now, take all the cans (w/o - or +), find those
		   that that are musts (+), if any, and remove the
		   nots (-) */

	$size_musts = sizeof($musts);
	$size_cans  = sizeof($cans);


	if( ($size_musts == 0) && ($how_many_musts > 0) ) {
							// searched using '+', but none found
		$total = array();

	} elseif( ($size_musts > 0) && ($size_cans > 0) ) {

		 while(list($k,$v) = each($musts)) {

	 		if(isset($cans["$k"])) {
				$total["$k"] = $cans["$k"] + $v;
			} else {
				$total["$k"] = $v;
			}
		  }

	} elseif( ($size_musts > 0) && ($size_cans == 0) ) {

		$total = $musts;

	} else {

		 $total = $cans;  // no musts, so we can use all of the cans.

	}

	if(is_array($nots)) {
	  $so_t = sizeof($total);
	  $so_n = sizeof($nots);

		if($so_n<=$so_t) { // for speed, try to each() the smallest array

			while(list($k,$v) = each($nots)) {
			 unset($total["$k"]);
			}

		} else {

			while(list($k,$v) = each($total)) {
			 if( isset($nots["$k"]) ) {
				 unset($total["$k"]);
			 }
			}
			// added by hans 8/24/00, fixes bug
			// that occurred when there were more
			// 'nots' than 'total' (somewhat rare)
			reset($total);
		}

	}


	if(!is_array($total)) {
		return FALSE;
	}

	$size_total = sizeof($total);

	if($size_total>0) {
		arsort($total);
	}

	$end_result = $num_results + $start_results;

	$i = $j = 0;

	while(list($k,$v) = each ($total)) {

		if($j>=$end_result) {
			break;
		}
	
		if($i<=$num_results && $j>=$start_results) {
			list($title_offset_start,$title_offset_end) = explode(":",$k);

			$title = $this->get_title($title_offset_start,$title_offset_end,$titles_fp);
			$array["$title"] = $v;
			$i++; $j++;;
		} else {
			$j++; 
		}

	}

	$this->title_offsets_close($title_offsets_fp);
	$this->title_close($titles_fp);

	return array("result_count"=>$size_total,"results"=>$array);
} 

/* ******************* /Search Functions ****************** */





/* ******************* Merge Functions  ****************** */

function ticker($j=0) {
	$backspace = chr(8);

	switch($j) {
		case 0:
			$o = "/"; $j++; break;
		case 1:
			$o = "-"; $j++; break;
		case 2:
			$o = "\\"; $j++; break;
		case 3:
			$o = "|"; $j=0; break;
		default:
			$j=0;

	}
	print "$backspace$o"; flush();
	return $j;
}


function sort_all() {

        for($j=0;$j<strlen(A);$j++) {
		$f = TMP_DIR . "/" . substr(A,$j,1);
		if(!file_exists($f) or (filesize($f) == 0) ) {
			continue; #		print "warning: file $f does not exist, cannot be sorted, skipping...\n";
		}
		if(VERBOSITY > 2) print "sorting temporary file $f\n";
		exec(SORT . " -bf -o $f" . "s $f");
		rename("$f" . "s", "$f");
        }

}

function merge() {

 $this->sort_all();

 $index = $this->idx;

 $merger_pointers = $this->merger_open($index);
 
 $fp = fopen(DATA_DIR . "/$index.index.data","w");
 fputs($fp,"\n"); // problem with finding first word in index if we don't do this

	while(list($k,$v) = each($merger_pointers)) {

		if($k == 'title_offsets') continue;
		$f = TMP_DIR . "/$k";

	 	$fs = filesize($f);
		if( !file_exists("$f") or ($fs==0) ) 
							continue;

		if(VERBOSITY > 2) print Chr(8) . "merging words starting with $k...\n";

		$offsets[$k.'s'] = ftell($fp)-1; // position in index $k starts

		$sfp = fopen("$f", "r");

		while(!feof($sfp)) {
			$line = fgets($sfp,255);

			if(VERBOSITY>2) $j=$this->ticker($j);

			list($w,$o) = explode(" ",trim($line));
			if(!$w) continue;

			if($w=='' && ($ok)) continue;

			$ok = 1; 		// above, we check to see if the
						// line is blank but it always
						// starts that way, so we do this
						// to skip it

			if($word == $w) {
				$these_offsets[] = "$o";
			} elseif($word=='') { // first word for this letter
				$word=$w;
				$these_offsets[] = "$o";
			} else {

				$cos = count($these_offsets);
				for($z=0;$z<$cos;$z++) {
					list($t1,$t2,$t3) = explode(":",$these_offsets[$z]);
					$hash["$t1:$t2"] += $t3;
				}

				$offset_told1 = ftell($merger_pointers["title_offsets"]);

				fputs($merger_pointers["title_offsets"], "" . serialize($hash) ."\n");

				$offset_told2 = ftell($merger_pointers["title_offsets"]) - $offset_told1;

				fputs($fp," $word $offset_told1:$offset_told2\n");

						/* just testing something new
							$t = crc32($word); 
							$a = pack("l*",$t);
							$o1 = pack("l*",$offset_told1);
							$o2 = pack("l*",$offset_told2);
							fputs($fp," $a $o1:$o2\n");
						*/
				unset($hash);

				unset($these_offsets); // lose old data
				$these_offsets[] = "$o";
				$word=$w;

			}

		unset($array[$i]);
		}

		$offsets[$k.'e'] = (ftell($fp)-1); // position in index $k ends
	}


	fclose($fp);
	$this->merger_close($merger_pointers);

	$fp = fopen(DATA_DIR . "/$index.word_offsets.data","w");
		fputs($fp,serialize($offsets));
	fclose($fp);

} // merge()

/* ******************* /Merge Functions ****************** */



















} /* Thus, we end our class. */

?>

