<?php

/* this is a screwy little function.  Use it to find items in
   more than one associative array that are in common.  If you
   pass it an empty array, there can be nothing in common.  So, 
   if you are looping through a list of more than two arrays,
   DO NOT declare an array for the first ($m) item the FIRST
   time through.  If you do, there will never be anything in 
   common.  If you pass it an uninitiated variable the
   first time through, it will return the other.  I don't
   recommend trying to use this function for anything but this,
   as it's got lots of potential problems if not called correctly. */

function in_common($m,$n) {

	if(!is_array($m)) {  // returning n because m is not an array
		return $n;
	} elseif(!is_array($n)) { // returning m because n is not an array
		return $m;
	}

	$som = sizeof($m);
	if($som == 0) return array(); /* if it's size is 0, there can't be 
					 anything in common with the other
					 array. You might check the return
					 of this for size.  If it's 0, nothing
					 will ever be in common, and you can 
					 pretty well return to doing other
					 things without continuing to look */
	$son = sizeof($n);
	if($son == 0) return array(); /* if it's size is 0, there can't be 
					 anything in common with the other
					 array. You might check the return
					 of this for size.  If it's 0, nothing
					 will ever be in common, and you can 
					 pretty well return to doing other
					 things without continuing to look */

        if( ($som<=$son) ) {

                while(list($k,$v) = each ($m)) {
                        if(isset($n["$k"])) $o["$k"] = $v + $n["$k"];
                }

        } else {

                while(list($k,$v) = each ($n)) {
                        if(isset($m["$k"])) $o["$k"] = $v + $m["$k"];
                }

        }

	if(!is_array($o)) {
		return array();
	} else {
		return $o;
	}
}

//$a[] = array("harold"=>9);
//$a[] = array();
$a[] = array("george"=>2,"hans"=>3,"annie"=>3);
$a[] = array("hans"=>1,"brent"=>2,"annie"=>1,"megan"=>2);
$a[] = array("annie"=>2,"brent"=>5,"hans"=>1);


for($i=0;$i<count($a);$i++) {
	$o = in_common($o,$a[$i]);
	if(sizeof($o)==0) {
		print "returning, there can never be anything in common with nothing\n";
		exit;
	}
}

print "In Common: \n";
	while(list($k,$v) = each($o)) {
		print "$k = $v\n";
	}


?>
