<?php

// config.php: setup some important config options

//		change this!
define("DATA_DIR","/home/hans/www/hansanderson/search/data"); 

       /* What directory can we use for the data files? Perhaps
          this directory could be writable by the program indexing...
          Perhaps as well, this partition will have enough space
          so that we can use it?  This directory needs to exist
          before you try to use it. */

//		and this!
define("TMP_DIR","/home/hans/www/hansanderson/search/tmp");
 
       /* What directory can we use for temporary files? Perhaps
          this directory could be writable by the program indexing...
          Perhaps as well, this partition will have enough space
          so that we can use it?  This directory needs to exist
          before you try to use it. */

define("VERBOSITY",3);

	/* How verbose should the indexer and merger be?  This doesn't
	   affect the search at all.  1 shows errors, 3 shows progress
	   and errors */

define("MIN_WORD_LEN",3); 

       /* What is the length of shortest word we'll try to index?  */

define("MAX_WORD_LEN",25); 

       /* How long is the longest word we'll try to index?  */

define("WORD_FACTOR",1); 

       /* What is the normal word factor?  Set this to 1 for normal.  See the
	  docs for info on word factor (:wf3: syntax) */

define("PLURAL_STEM",TRUE); # or FALSE

	/* If you set to TRUE, words will be stripped of their plural on index and
	   search.  This makes the index a bit smaller, but also makes the matches
	   a little better because fences matches fence, etc. */

define("A","abcdefghijklmnopqrstuvwxyz0123456789");

	/* Define the alphabet.  Leave this alone */

define("SORT","/bin/sort");
	/* where is your unix "sort" command line program?  Do a 'which sort' to 
	   find out */
?>
